#include "StringParsing.h"

std::string Remove_String_WhiteSpaces(std::string const str_in) {
	std::string str_ret = str_in;
	long prev_str_ret_len = str_ret.length();
	long cur_str_ret_len = -1;
	std::regex e("(\\s+)", icase); //ECMAScript | icase
	std:string empty_str = "";
	while (cur_str_ret_len != prev_str_ret_len) {
		prev_str_ret_len = cur_str_ret_len;
		str_ret = std::regex_replace(str_ret, e, empty_str, std::regex_constants::match_default);
		cur_str_ret_len = str_ret.length();
	}
	return str_ret;

}

std::string Remove_String_WhiteSpaces2(std::string const str_in) {
	std::string s = str_in;
	s.erase(remove_if(s.begin(), s.end(), ::isspace), s.end());
	return s;
}

std::string CombineStringsWSeparator(std::vector<std::string> Extracted_sections, std::string strSeparator_in) {

	int num_sections = Extracted_sections.size();
	if (num_sections == 0) {
		return "";
	}

	if (num_sections == 1) {
		return Extracted_sections[0];
	}

	std::string retCmbStr = "";
	for (int iSec = 0; iSec <= num_sections - 2; iSec++) {
		retCmbStr = retCmbStr + Extracted_sections[iSec] + " " + strSeparator_in;
	}
	retCmbStr = retCmbStr + Extracted_sections[num_sections - 1];

	return retCmbStr;

}

std::vector<std::string> ParseStrVbarSeparated(std::string str_in) {

	std::string TestStr1 = str_in;

	std::vector<std::string> Extracted_sections;

	std::regex e("([^\\|]*)\\|(.*)", icase); //ECMAScript | icase

	TestStr1 = Remove_String_WhiteSpaces(TestStr1);
	std::smatch sm;
	while (TestStr1.length() > 0) {
		bool matchF1 = std::regex_search(TestStr1, sm, e);
		//cout << matchF1 << "*" << endl;
		if (!matchF1) {
			Extracted_sections.push_back(TestStr1);
			break;
		}
		if (sm.size() >= 2) {
			Extracted_sections.push_back(sm[1].str());
		}
		if ((sm[2].str()).length() > 0) {
			TestStr1 = sm[2].str();
		}
		else {
			break;
		}
	}

	return Extracted_sections;
}

std::vector<std::string> ParseStrCommaSeparated(std::string str_in) {

	std::string TestStr1 = str_in;

	std::vector<std::string> Extracted_sections;

	std::regex e("([^,]*),(.*)", icase); //ECMAScript | icase

	TestStr1 = Remove_String_WhiteSpaces(TestStr1);
	std::smatch sm;
	while (TestStr1.length() > 0) {
		bool matchF1 = std::regex_search(TestStr1, sm, e);
		//cout << matchF1 << "*" << endl;
		if (!matchF1) {
			Extracted_sections.push_back(TestStr1);
			break;
		}
		if (sm.size() >= 2) {
			Extracted_sections.push_back(sm[1].str());
		}
		if ((sm[2].str()).length() > 0) {
			TestStr1 = sm[2].str();
		}
		else {
			break;
		}
	}

	return Extracted_sections;
}


std::vector<std::string> ParseStrCharSeparated(std::string str_in, std::string delimChar) {

	std::string TestStr1 = str_in;

	std::vector<std::string> Extracted_sections;

	TestStr1 = Remove_String_WhiteSpaces2(TestStr1);

	if (TestStr1.compare("") == 0) {
		Extracted_sections.push_back("");
	}
	else {
		std::istringstream ss(TestStr1);
		std::string token;

		while (std::getline(ss, token, *(delimChar.c_str()))) {
			Extracted_sections.push_back(token);
		}
		std::string lastchar = TestStr1.substr(TestStr1.length() - 1, 1);
		if (lastchar.compare(delimChar) == 0) {
			Extracted_sections.push_back("");
		}
	}

	return Extracted_sections;
}

